import { createRouter, createWebHistory } from 'vue-router';
import { routes, handleHotUpdate } from 'vue-router/auto-routes';
import { setupRouterGuard } from './guard';

export const router = createRouter({
  history: createWebHistory(import.meta.env.BASE_URL),
  routes,
  strict: true
});

if ($__DEV__) Object.assign(window, { router });

setupRouterGuard(router);

if (import.meta.hot) {
  handleHotUpdate(router);
}
